Getting Started with ColorPicker Web Component
Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.
Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.
Quick start
- Install the package:
npm install smart-webcomponents
- Load the ColorPicker module (ES module script):
<script type="module" src="node_modules/smart-webcomponents/source/modules/smart.colorpicker.js"></script>
- Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):
<link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />
- Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host
div(you mount programmatically with appendTo):
Semantic element (id matches the selector in Smart()):
<smart-color-picker id="colorpicker"></smart-color-picker>
Host container (id matches appendTo on Smart.ColorPicker):
<div id="colorpickerContainer"></div>
- Initialize after the module loads: define a const colorpickerOptions object, then either bind with Smart('#colorpicker', ...) on the semantic tag or use new Smart.ColorPicker({ ...colorpickerOptions, appendTo: '#colorpickerContainer' }) on the host
div:
<script type="module"> import 'node_modules/smart-webcomponents/source/modules/smart.colorpicker.js'; const colorpickerOptions = { value: "#ff0000" }; // Option A - semantic <smart-color-picker> with id="colorpicker" Smart('#colorpicker', class { get properties() { return colorpickerOptions; } }); // Option B - host div id="colorpickerContainer" // const colorpickerInstance = new Smart.ColorPicker({ // ...colorpickerOptions, // appendTo: '#colorpickerContainer' // }); // Option C - constructor(selector, options), then append the returned element yourself // const myColorPicker = new Smart.ColorPicker('#colorpicker', colorpickerOptions); // document.body.appendChild(myColorPicker); </script>
Uncomment Option B when you use the host
div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.ColorPicker('#colorpicker', colorpickerOptions) with appendChild, and document.createElement('smart-color-picker') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components). - Serve the folder over HTTP (or use your bundler dev server) and open the page.
Runtime cookbook
Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.ColorPicker({ ...options, appendTo: '#...' }); new Smart.ColorPicker('#colorpicker', colorpickerOptions) plus appendChild on the returned element; and document.createElement('smart-color-picker') then assigning options via .props or Object.assign on the element.
Constructor with a selector string and options, then append the returned element (for example const myColorPicker = new Smart.ColorPicker('#colorpicker', colorpickerOptions)):
const colorpickerOptions = { value: "#ff0000" };
const myColorPicker = new Smart.ColorPicker('#colorpicker', colorpickerOptions);
document.body.appendChild(myColorPicker);
Create with document.createElement('smart-color-picker'), assign properties (same as any custom element), then append:
const colorpickerOptions = { value: "#ff0000" };
const colorpicker = document.createElement('smart-color-picker');
Object.assign(colorpicker, colorpickerOptions);
document.body.appendChild(colorpicker);
Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):
import "../../source/modules/smart.colorpicker.js";
document.readyState === 'complete' ? init() : window.addEventListener('load', init);
function init() {
const colorpickerOptions = { value: "#ff0000" };
const colorpicker = new Smart.ColorPicker({
...colorpickerOptions,
appendTo: '#colorpickerContainer'
});
}
Append to the DOM:
const container = document.getElementById('colorpicker-container');
container.appendChild(colorpicker);
Remove from the DOM:
colorpicker.remove();
Set a property:
colorpicker.disabled = true; colorpicker.theme = 'dark';
Get a property value:
const isDisabled = colorpicker.disabled; const currentTheme = colorpicker.theme;
Invoke a method:
colorpicker.refresh(); colorpicker.focus();
Add event listener:
colorpicker.addEventListener('change', (event) => {
console.log('change triggered:', event.detail.oldValue);
});
Remove event listener:
const handleColorPickerEvent = (event) => {
console.log('change triggered:', event.detail.oldValue);
};
colorpicker.addEventListener('change', handleColorPickerEvent);
colorpicker.removeEventListener('change', handleColorPickerEvent);
Accessibility
The ColorPicker component follows WAI-ARIA best practices:
- Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
- ARIA roles - Appropriate roles and labels are applied automatically
- Focus management - Visible focus indicators for keyboard users
- Screen readers - State changes are announced to assistive technology
- High contrast - Supports Windows High Contrast Mode and forced colors
For custom labeling, set aria-label or aria-labelledby attributes on the component.
Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular ColorPicker - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/colorpicker/overview

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import ColorPickerModule from smart-webcomponents-angular/colorpicker: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { ColorPickerModule } from 'smart-webcomponents-angular/colorpicker';

4 Root component (standalone)

Add ColorPickerModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { ColorPickerComponent } from 'smart-webcomponents-angular/colorpicker';

import { ColorPickerModule } from 'smart-webcomponents-angular/colorpicker';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ ColorPickerModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('colorpicker', { read: ColorPickerComponent, static: false }) colorpicker!: ColorPickerComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-color-picker as needed:

 <div class="demo-description">
    <h1>smartColorPicker allows picking a color from a drop-down</h1>
</div>
<smart-color-picker #colorpicker enable-custom-colors></smart-color-picker>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put ColorPickerModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put ColorPickerModule from smart-webcomponents-angular/colorpicker on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { ColorPickerModule } from 'smart-webcomponents-angular/colorpicker';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, ColorPickerModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The ColorPicker component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React ColorPicker Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/colorpicker/overview/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import { ColorPicker } from 'smart-webcomponents-react/colorpicker';

const App = () => {
  const handleChange = (event) => {
    console.log("New Color: " + event.detail.value);
  };

  return (
    <div>
      <div className="demo-description">
        <h1>smartColorPicker allows picking a color from a drop-down</h1>
      </div>
      <ColorPicker onChange={handleChange} enableCustomColors />
    </div>
  );
};

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { ColorPicker, ColorPickerProps } from 'smart-webcomponents-react/colorpicker';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The ColorPicker component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.